' JBeam-Automations-Beispiel
' Erstellt einen Kreisring
' Autor: Kai Gerd Schwebke
' Datum: 26.6.1998

' Hauptprogramm
sub Main
    ret = MsgBox("Erstellen eines Kreisringes.", vbOKCancel, "JBeam-Automations-Beispiel")

    if ret = 1 then
	' Automation-Bridge instanziieren
	set jbc = CreateObject("JBeamAutomationBridge.Model.1")

	if jbc.isValid = False then
	    call MsgBox("Automation-Bridge nicht korrekt initialisiert!", vbCritical, "Fehler")
	    exit sub
	end if

	' Parameter abfragen
	radius = CDbl(InputBox("Radius", "Kreisring", "5"))
	segments = CInt(InputBox("Segmente", "Kreisring", "20"))

	' JBeam fr User-Eingaben sperren
	jbc.lock

	' Lschen
	jbc.resetApp

	if segments > 1000 then
	    call MsgBox("Die Maximale Segmentzahl betrgt "+CStr(MaxSegments)+" Segmente", vbCritical, "Fehler")
	    exit sub
	end if

	' Knoten erzeugen
	pi2 = 3.1415 * 2
	inc = pi2 / segments
	dim node(1000)
	n = 0
	for phi = 0 to (pi2 - 0.9* inc) step inc
	    z = radius * cos(phi)
	    x = -radius * sin(phi)
	    node(n) = jbc.addNode(x, z)
	    n = n + 1
	next

	' Ersten, unteren Knoten voll einspannen
	call jbc.setConstraints(node(0), True, True, True)

	' Euler-Bernoulli-Balkenelemente erzeugen
	for i = 0 to (n-2)
	    call jbc.addEBBeam(node(i), node(i+1))
	next

	call jbc.addEBBeam(node(n-1), node(0))
    end if
end sub

call Main

