/*
    JLauncher - Win32 Java[TM] program starter

    Copyright (C) 1998   Kai Gerd Schwebke

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>

#include <windows.h>
#include <winbase.h>
#include <winreg.h>



char errMsg[128]="";

/* get Path of the JRE */
int getJRE(char* jrePath, int vNum, int v2Num, int mNum)
{
	HKEY regSoftware;
	int retval=0;
		
	if (RegOpenKeyEx(
			HKEY_LOCAL_MACHINE, 
			"SOFTWARE",
			0,
			KEY_READ,
			&regSoftware
		) == ERROR_SUCCESS)
	{
		HKEY regVendor;
		if (RegOpenKeyEx(
				regSoftware,
				"JavaSoft",
				0,
				KEY_QUERY_VALUE,
				&regVendor
			) == ERROR_SUCCESS)
		{
			HKEY regProduct;
			if (RegOpenKeyEx(
					regVendor,
					"Java Runtime Environment",
					0,
					KEY_QUERY_VALUE,
					&regProduct
				) == ERROR_SUCCESS)
			{
				HKEY regVersion;
				char vString[10];
				sprintf(vString, "%d.%d", vNum, v2Num);
				if (RegOpenKeyEx(
						regProduct,
						vString,
						0,
						KEY_QUERY_VALUE,
						&regVersion
					) == ERROR_SUCCESS)
				{
					unsigned char buff[128];
					unsigned long type=0;
					unsigned long size=128;

					if (RegQueryValueEx(
							regVersion,
							"MicroVersion",
							0,
							&type,
							buff,
							&size
						) == ERROR_SUCCESS)
					{
						if ( atoi(buff) < mNum )
						{
							sprintf(errMsg, "MicroVersion is %s but at least %d is required", buff, mNum);
							retval=7;
						}
					} else {
						strcpy(errMsg, "can't open Key 'MicroVersion'");
						retval=6;
					}

					
					type=0;
					size=128;
					if (RegQueryValueEx(
							regVersion,
							"JavaHome",
							0,
							&type,
							buff,
							&size
						) == ERROR_SUCCESS)
					{
						strcpy(jrePath, (char*)buff);
					} else {
						strcpy(errMsg, "can't open Key 'JavaHome'");
						retval=5;
					}

					RegCloseKey(regVersion);
				} else {
					sprintf(errMsg, "can't open Key '%s'", vString);
					retval=4;
				}
				RegCloseKey(regProduct);
			} else {
				strcpy(errMsg, "can't open Key 'Java Runtime Environment'");
				retval=3;
			}
			RegCloseKey(regVendor);
		} else {
			strcpy(errMsg, "can't open Key 'JavaSoft'");
			retval=2;
		}
		RegCloseKey(regSoftware);
	} else {
		strcpy(errMsg, "can't open Key 'SOFTWARE'");
		retval=1;
	}
	return retval;
}

int main(int argc, char* argv[])
{
	char jrePath[128];
	int errval;
	int retval=0;
	char lMethod;
	int vNum;
	int v2Num;
	int mNum;

	if (argc != 9)
	{
		printf("\n usage: JLauncher vNum v2Num mNum exec classpath addargs class launchmethod\n");
		return 2;
	}

	lMethod=toupper(argv[8][0]);
	if ( (lMethod!='W') && (lMethod!='C') )
	{
		printf("\n launchmethod must be 'W' for windowed or 'C' for console applications\n");
		return 4;
	}

	vNum = atoi(argv[1]);
	v2Num = atoi(argv[2]);
	mNum = atoi(argv[3]);

	if ( (errval=getJRE(jrePath, vNum, v2Num, mNum)) == 0 )
	{
		char cmd[512];
		/* printf("\n jre%d.%d.%d is '%s'\n", vNum, v2Num, mNum, jrePath); */
		sprintf(cmd, "%s%s -cp \"%s\" %s %s", jrePath, argv[4], argv[5], argv[6], argv[7]);
		/* printf("\n cmd='%s'\n", cmd); */
		if (lMethod=='W')
		{
			retval = ( WinExec(cmd, SW_SHOWNORMAL) <= 31);
		} else {
			_flushall();
			retval = system(cmd);
		}
	} else {
		char mboxMsg[256];
		printf("\n jre%d.%d.%d not installed (%s)\n", vNum, v2Num, mNum, errMsg);
		sprintf(mboxMsg, "Sun JRE %d.%d not properly installed!\n(%s)\n\nYou can get JRE from http://www.java.sun.com/.", vNum, v2Num, errMsg);
		MessageBox(0, mboxMsg, "Error: cannot launch program", MB_OK|MB_ICONERROR);
		retval=3;
	}

	return retval;
}